=== debian/watch ===
version=3
 https://files.freedv.org/codec2/ codec2-(.+)\.tar\.xz
