## codec2 0.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,8 +35,9 @@
 # file at some point.
 #
 set(CODEC2_VERSION_MAJOR 0)
-set(CODEC2_VERSION_MINOR 7)
+set(CODEC2_VERSION_MINOR 8)
 # Set to patch level if needed, otherwise leave FALSE.
+# Must be positive (non-zero) if set, since 0 == FALSE in CMake.
 set(CODEC2_VERSION_PATCH FALSE)
 set(CODEC2_VERSION "${CODEC2_VERSION_MAJOR}.${CODEC2_VERSION_MINOR}")
 # Patch level version bumps should not change API/ABI.
@@ -85,16 +86,17 @@
 
 #
 # Find the svn revision if this is a working copy.
-# WORK IN PROGRESS
-# Works ok if it is a working copy but errors out if not.
-#
-#find_package(Subversion)
-#if(Subversion_FOUND)
-#   Subversion_WC_INFO(${CMAKE_CURRENT_SOURCE_DIR} CODEC2)
-#   message(STATUS "codec2 svn revision: ${CODEC2_WC_REVISION}")
-#else(SUBVERSION_FOUND)
-#   message(WARNING "Subversion not found. Can not determine svn revision.")
-#endif(SUBVERSION_FOUND)
+#
+get_filename_component(_src_dir "${CMAKE_SOURCE_DIR}" NAME)
+if("${_src_dir}" STREQUAL "codec2-dev")
+    find_package(Subversion QUIET)
+    if(Subversion_FOUND)
+        Subversion_WC_INFO(${CMAKE_CURRENT_SOURCE_DIR} CODEC2)
+        message(STATUS "Codec2 svn revision: ${CODEC2_WC_REVISION}")
+    else(Subversion_FOUND)
+        message(WARNING "Subversion not found. Can not determine svn revision.")
+    endif(Subversion_FOUND)
+endif()
 
 
 #
@@ -140,6 +142,10 @@
 
 configure_file ("${PROJECT_SOURCE_DIR}/cmake/config.h.in"
                 "${PROJECT_BINARY_DIR}/config.h" )
+# Output path is such that #include <codec2/version.h> in codec2.h works
+set(CODEC2_VERSION_PATH "${PROJECT_BINARY_DIR}/codec2")
+configure_file ("${PROJECT_SOURCE_DIR}/cmake/version.h.in"
+                "${CODEC2_VERSION_PATH}/version.h" )
 include_directories(${PROJECT_BINARY_DIR})
 
 # CMake Package setup
@@ -164,7 +170,7 @@
     # Find speex library
     #
     message(STATUS "Looking for Speex DSP library.")
-    find_path(SPEEXDSP_INCLUDE_DIR speex/speex.h)
+    find_path(SPEEXDSP_INCLUDE_DIR speex/speex_preprocess.h)
     find_library(SPEEXDSP_LIBRARY speexdsp)
     message(STATUS "  Speex DSP headers: ${SPEEXDSP_INCLUDE_DIR}")
     message(STATUS "  Speex DSP library: ${SPEEXDSP_LIBRARY}")
