=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: A. Maitland Bottoms <bottoms@debian.org>
 Build-Depends: cmake, debhelper (>= 9), libsamplerate0-dev, libspeexdsp-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.4
 Homepage: http://www.rowetel.com/blog/?page_id=452
-Vcs-Git: git://anonscm.debian.org/users/bottoms/pkg-codec2.git
-Vcs-Browser: http://anonscm.debian.org/cgit/users/bottoms/pkg-codec2.git/
+Vcs-Browser: https://salsa.debian.org/bottoms/pkg-codec2
+Vcs-Git: https://salsa.debian.org/bottoms/pkg-codec2.git
 
 Package: codec2
 Architecture: any
@@ -27,7 +27,7 @@
  .
  This package contains sample data and supporting examples.
 
-Package: libcodec2-0.7
+Package: libcodec2-0.8
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -45,7 +45,7 @@
 Architecture: any
 Section: libdevel
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libcodec2-0.7 (= ${binary:Version}), ${misc:Depends}
+Depends: libcodec2-0.8 (= ${binary:Version}), ${misc:Depends}
 Suggests: pkg-config
 Description: Codec2 library development files
  Codec2 is an audio codec especially designed for compressing voice at
